# ----------------------------------------------------------------
# module       : genDiagImg.py
# invocation   : python genDiagImg.py <datatype> <nRows> <nCols> <rawBin.dtype> <outPath.img>
# notes        : datatype format as a string, choices: "float32"|"uint8"|"int16"|"uint16"|"int32"|"uint32"| etc 
# warning      : datatype (abbreviated) identifiers like "flt32" are NOT yet supported
# revision     : 2014-10-21T15:22:00
# history      : 2014-09-05T02:14:00
# dependencies : numpy, scipy
# author       : joe glassy
# note         : Gnomes default image viewer is 'gthumb'
#

import os,sys
import time,random, math
import numpy as np
import scipy
from scipy.misc import toimage

#
if __name__ == "__main__":
	'''
	main()
	'''
	defaultViewerApp = "gthumb"
	rawBinPath = "default_2D_data.float32"
	inpImgDatatype = "float32"
	outImgFormat = "png"
	outImgPath = "diag.png"
	nRows = 1624
	nCols = 3856
	nPix = nRows * nCols
	if len(sys.argv) >= 6:
		inpImgDatatype = sys.argv[1]
		nRows = int(sys.argv[2])
		nCols = int(sys.argv[3])
		rawBinPath = sys.argv[4]
		outImgPath = sys.argv[5]
	else:
		print("%s invocation "%(sys.argv[0]))
		print("python genDiagImg.py <datatype> <nRows> <nCols> <rawImageBinPath.dtype> <outPath.img>\n")
		sys.exit(-1);
	
	nPix = nRows * nCols
	#
	print("\n%s started %s"%(sys.argv[0], time.ctime()))
	sciAry = np.fromfile(rawBinPath,dtype=inpImgDatatype).reshape(nRows,nCols)

	# Next create a viewable image file. Do NOT assume any particular extension
	# Fetch all text up to and including a dot, if one exists
	if rawBinPath.find(".") >0:
		outImgPath = rawBinPath[:rawBinPath.find('.')] + "."+outImgFormat
	else:
		outImgPath = rawBinPath + "." + outImgFormat

	# Create a simple greyscale from float32 or uint8 or other image
	toimage(sciAry).save(outImgPath,outImgFormat)

	# perform a quick display of image, using gthumb by default
	# toimage(sciAry).show() , or, do this:
	osCmd = defaultViewerApp + " " + outImgPath + " & \n"
	os.system(osCmd)
	del(sciAry)
	print("\n%s completed oscmd(%s) at %s"%(sys.argv[0],osCmd, time.ctime()))
	# end: main()
