# script  : onecol.py
# purpose : calculate simple univariate statistics on a single column of CSV text data
# revised : 2014-10-06T11:00:00
# notes   : TBD refactor or extend, to allow for input piped in from stdin as well
import os,sys
import time,random,math
import numpy as np
#

if __name__ == "__main__":
	'''
	main()
	'''
	if len(sys.argv) >= 2:
		inCsvdataPath = sys.argv[1]
	if not os.path.exists(inCsvdataPath):
		print("\nFAILED to locate input data(%s)"%(inCsvdataPath))
		sys.exit(-1)
	# read data into a list, convert to numpy vector
	dtaLis = [xVal for xVal in open(inCsvdataPath) if not xVal.startswith("#")]
	dtaAry = np.array(dtaLis,dtype='float64')  # leave shape as a 1D vector...
	thisMedian = np.median(dtaAry)
	thisMin  = dtaAry.min()
	thisMax  = dtaAry.max()
	thisMean = dtaAry.mean()
	thisStdev= dtaAry.std()
	# calculate 16 frequency bins
	histVal,bin_edges = np.histogram(dtaAry)
	print("INPUT %s summarized on %s "%(inCsvdataPath,time.ctime()))
	print("min %.3f max %.3f median %.3f mean %.3f stddev %.3f"%(thisMin,thisMax,thisMedian,thisMean,thisStdev))
	print("histogram-bin-edges %s"%(bin_edges))
	print("histogram %s"%(repr(histVal)))
	del(dtaAry)
	del(dtaLis)
	# end::main()
	
