// --------------------------------------------------------------
// module       : fpar_qa_bin_util.h for tcf_spin v3.2, LEAD_FORK with new ADT names
// purpose      : Data structures and function prototypes for 'fpar_qa_bin_util.c' utilties module.
// project      : SMAP L4C science development.
// dependencies : HDF4, FRM_API
// revision     : 2014-02-15T11:55:00-07:00
// author       : joe glassy , Lupine Logic Inc.

/*
 module       : fpar_qa_bin_util.h
 purpose      : Data structures and function prototypes for 'fpar_qa_bin_util.c' utilties module.
 project      : SMAP L4C science development.
 dependencies : 
 revision     : v3.1, Initial reformatting -- laj 09/10/13
 author       : Lucas A. Jones; lucas@ntsg.umt.edu
 notes        :

*/


#ifndef QA_BIN_UTIL_DEF
#define QA_BIN_UTIL_DEF 1


typedef struct tagQcBitAdt {

  /*holds full uint8 qc field*/
  char             bits[9]; 

  uint8            qc;

  /*holds subunit ('bitword') fields read
   *from right to left in the bitbuffer*/
  unsigned char  modland  : 1;   /*MODLAND_QC field*/
  unsigned char  sensor   : 1;   /*Sensor (Terra/Aqua) field*/
  unsigned char  detector : 1;   /*DeadDetector field*/
  unsigned char  cloud    : 2;   /*CloudState field*/
  unsigned char  scf      : 2;   /*SCF_QC field (minus left-most bit)*/
  unsigned char  fillval  : 1;   /*Fill values, left-most bit of SFC_QC (my own designation) */

} QcBitAdt;


uint8   fpar_qa_bin_reclas(uint8 fpar_qa);
void    set_qa_state(QcBitAdt qcBitObj, uint8 *fpar_rank);
void    bitword_parse(QcBitAdt *qcBitObj_p);
void    printbit(uint8 a, char buff[]);
void    getbits(char srcbuff[], char desbuff[], int offset, int n);
void    printf_qcbits(QcBitAdt qcBitObj);

uint32  getBitsFromUint32(const int32 strt_at,const int32 end_at,uint32 dta);

#endif
