// --------------------------------------------------------------
// function: l4c_DAILY_DSET_NAMES.h
// purpose : declare l4c_DAILY default input (and output) dataset names
// author  : joe glassy
// revised : 2014-01-27T12:57:00
// history : n/a
// notes   : TBD, deprecate this, use RIP file symbols instead.
// notes   : Names defined here are defaults, overridden by same name
//           in a session's live RIP file.
// --------------------------------------------------------------

#ifndef L4C_DAILY_DSET_NAMES_DEF 

#define L4C_DAILY_DSET_SNAMES_DEF 1


// HDF5 Dataset DSNAME_{xxx} INPUT HDF4 name defaults
#define DSNAME_GRID_NAME 	    "MOD_Grid_MOD15A2"	 // the grid name
#define DSNAME_FIELD_DATA 	    "Fpar_1km"		     // data field one (Fpar)
#define DSNAME_FIELD_QC 	    "FparLai_QC"		 // data field three (QC)
#define DSNAME_FIELD_QC_EXTRA 	"FparExtra_QC"	     // data field three (QC)

// PFT_M09_mask is now MCD12Q1_M09_lc_mask_uint8
// PRIOR, was:  DSNAME_PFT_M09_MASK   "PFT_M09_mask"
#define DSNAME_PFT_M09_MASK     "MCD12Q1_M09_lc_mask_uint8"

// new 1KM 2D full grid, pixel filter mask...
#define DSNAME_PIXFILTER_M01_MASK       "L4C_PIXFILTER_M01_MASK_uint8"

// new 1KM 1D sparse vector, pixel filter mask...
#define DSNAME_PIXFILTER_M01land_MASK   "L4C_PIXFILTER_M01land_MASK_uint8"

// HDF5 Dataset names in SMAP_L4_C_Ancillary.h5 are:

// from l4c_MODIS, UPDATED:
#define DSNAME_TILE_ROW_M01     "tile_r_M01_1km_ease2_template_int16"
#define DSNAME_TILE_COL_M01     "tile_c_M01_1km_ease2_template_int16"
#define DSNAME_TILE_HORI_HH_M01 "tile_h_M01_1km_ease2_template_uint8"
#define DSNAME_TILE_VERT_VV_M01 "tile_v_M01_1km_ease2_template_uint8"

// INPUT -- Declare default other INPUT HDF5 DATASET names
#define DSNAME_FT_QC        "FT_QC_M03"             
#define DSNAME_FT_ROLLING   "FT_ROLLING_M03"        
#define DSNAME_FT_AGE       "FT_ROLLING_AGE_M03"        

#define DSNAME_SOC_C0        "SOC/SOC_C0_M01" 
#define DSNAME_SOC_C1        "SOC/SOC_C1_M01" 
#define DSNAME_SOC_C2        "SOC/SOC_C2_M01" 
#define DSNAME_SOC_npp_sum   "SOC/NPP_SUM_M01"

// these 2D rasters go in SMAP_L4_C_SPINUP.h5 now
#define DSNAME_SOC_Cana0     "SOC_Cana0_M01" 
#define DSNAME_SOC_Cana1     "SOC_Cana1_M01" 
#define DSNAME_SOC_Cana2     "SOC_Cana2_M01" 

#define DSNAME_SOC_Cnum0     "SOC_Cnum0_M01" 
#define DSNAME_SOC_Cnum1     "SOC_Cnum1_M01" 
#define DSNAME_SOC_Cnum2     "SOC_Cnum2_M01" 
#define DSNAME_SOC_kmult_sum "KMULT_SUM_M01" 
#define DSNAME_SOC_Cx        "SOC/tcf_npp_sum_M01"

#define DSNAME_MET_SURFACE_FLAG     "SURFACE_FLAG_M03" 

#define DSNAME_MET_RAD              "RADIATION_SHORTWAVE_DOWNWARD_FLUX" 
#define DSNAME_MET_VPD              "VPD_AVG"
#define DSNAME_MET_QV2M_AVG         "QV2M_M09_AVG" 
#define DSNAME_MET_SM_ROOT_WET      "SM_ROOTZONE_WETNESS" 
#define DSNAME_MET_SM_SURFACE_WET   "SM_SURFACE_WETNESS" 
#define DSNAME_MET_TSOIL1           "SOIL_TEMP_LAYER1" 
#define DSNAME_MET_SURFACE_PRESSURE "SURFACE_PRESSURE" 
#define DSNAME_MET_T2M_AVG          "T2M_M09_AVG" 
#define DSNAME_MET_T2M_MAX          "T2M_M09_MAX" 
#define DSNAME_MET_T2M_MIN          "T2M_M09_MIN"


#endif
