// ---------------------------------------------------------------------
// module  : l4c_DAILY_MultiProc.h
// purpose : Implement prototype multi-processor task definition ADTs
// revised : 2014-10-28T16:17:00-07:00
// author  : joe glassy
// notes   : Prototype stub only, not yet implemented.
// --------------------------------------------------------------------


#ifndef L4C_DAILY_MultiProc_DEF

#define L4C_DAILY_MultiProc_DEF 1

#include "l4c_DAILY.h"

#define L4C_MULTIPROC_VERS_TAG "v5.0.2-2014-10-28T16:18:00-07:00"

// <JMG> 2014-10-28T16:05
// prototype only: build-time limit on concurrent tasks
#define L4C_MAX_MULTITASKS  64


// <JMG> 2014-10-28 added prototype container for future multithreaded
// implementation where each task-partition size may not be equal to others
// Note "build-time" limit L4C_MAX_MULTITASKS as 64, may increase anytime
typedef struct tagMultiProcTaskDef {
	size_t mtaskStartIdx;  // starting index if a partition
	size_t mtaskEndIdx  ;  // ending index if a partition
	size_t mtaskElemCount; // count of work items mapped to this task
	time_t mtaskStrtSec;   // datetime this task started
	time_t mtaskEndiSec;   // datetime this task ended
	char   mtaskUniqueId[128] ;   // MD5,hash, or UUID identifying subtask
	char   mtaskHostIP[32 ];      // IP4 or IP6 IP assoc with this task
	char   mtaskLabel[256];       // text label identifying subtask
	unsigned long mtaskPthreadId; // ID of thread or process owning this task
} MultiProcTaskDef ;

// prototype: container for K multi-processor task definitions
typedef struct tagMultiProcAdt {
	size_t mtaskCount ;
	// prototype uses fixed size array, later will be ptr to array
	MultiProcTaskDef mtaskDef[L4C_MAX_MULTITASKS];
} MultiProcAdt ;

#include "l4c_DAILY_prot.h"

#endif
