// --------------------------------------------------------------
// function: // l4c_PostProc9km.h
// purpose : declare function prototypes, for v3.2 era tcf_proc9km post processor
// author  : joe glassy
// revised : 4.1.9-2015-12-04T09:44:00,jmg, restart RSME implementation
// history : 4.1.8-2014-03-05T08:36:00,jmg, re-integrate with latest core codes using 
//           pre-processor template and existing v3.2 proc9km logic.
// history : 4.1.7-2014-02-21T15:43:00,jmg, BPLUT access fixed up, more runtime testing
// history : 4.1.6-2014-02-17T18:20:00, PASS 4 refactoring proceeding ok
// history : 4.1.5-2014-01-27T12:57:00
// history : 4.1.4-2014-01-14T17:25:00-07:00,wheat,jmg
// history : 2013-11-20T17:04:00-07:00
// history : 2013-11-01T09:31:00-07:00
// notes   : n/a


#ifndef L4C_POST_PROC_9KM_DEF
#define L4C_POST_PROC_9KM_DEF 1

#include "l4c_DAILY.h"
#include "l4c_DAILY_prot.h"
// import BPLUT entries
#include "l4c_DAILY_bplut.h"


#define POST_PROC9KM_VERS_TAG "4.1.9-2015-12-04T09:44:00-07:00"

//  <LAJ> 3/11/14 - Structure definitions below were moved to tcf_struct.h

/* // "type_struct" here is a direct namespace conflict with "type_struct" defined in */
/* // tcf_spin_v3.2's tcf_struct.h. This one is renamed. */
/* // Basic struct to arrange pft type summaries as an array of structures */

/* // PRIOR: "type_struct"  NEW: PftClassAggr9kmAdt  */
/* typedef struct tagPftClassAggr9kmAdt  { */
/*   uint8    *cnt ; */
/*   float32  *avg ; */
/*   float32   sum ; */
/*   uint8    *rank ; */
/* } PftClassAggr9kmAdt; */


/* // Landcover Data Structure */
/* // PRIOR: was pft_struct (namespace conflict).  NEW: Pft9kmAggrAdt */
/* //  the change root prefix "Pft9km" is intentionally different than above's "Aggr9km", */
/* //  to help better differentiate these two similar ADT names. */
/* typedef struct tagPft9kmAddrAdt { */
/*   // Fundamental input dataset (all others derived) */
/*   uint8             *dom_1km;    /\*Dominant cover type for each 1km grid cell*\/ */

/*   /\* The following derived types are calculated from 1km data (rather than 300m, the other c5 option)*\/ */
/*   /\* This is done because 1km is the fundemental resolution of the Gpp data*\/ */
/*   uint8             *dom_9km;    /\*Dominant cover type for each 9km grid cell (from 1km data)*\/ */
  
/* 	// recall that NLC is __ so is NOT equal to NPFT */
/*   PftClassAggr9kmAdt lc_type[NLC]; // was: 'type_struct', but now with namespace: PftClassAggr9kmAdt */

/*   uint8             *veg_tot;      /\*total number of cells with veg pft*\/ */
/*   uint8             *margveg_tot;  /\*total number of cells with marginal-veg pft that might be excluded or included*\/ */
/*   uint8             *nonveg_tot;   /\*total number of cells with non-veg pft*\/ */
/*   uint8             *msnglc_tot;   /\*total number of cells with msng pft*\/ */

/* } Pft9kmAggrAdt; */

 

/* // Basic struct to contain various state variable summaries */
/* // PRIOR: "var_float32_struct"  NEW: VarProc9kmFloat32Adt */
/* typedef struct  tagVarProc9kmFloat32Adt { */

/*   PftClassAggr9kmAdt   pft_9km[NPFT];  // average for each cover type within 9km grid cell */

/*   float32        *dom_1km;    */

/*   uint8          *cnt_9km;       // count of 1km grid cells within overlying 9km grid cell */
/*   float32        *std_9km;       // count of 1km grid cells within overlying 9km grid cell */
/*   float32        *avg_9km;       // spatial average of 1km grid cells within overlying 9km grid cell */

/*   uint8          *rank_9km;      // qa rank  */

/*   // Intermediate variables for average and stdev. calculations */
/*   float32         sum_9km;       // sum of 1km grid cells within overlying 9km grid cell */
/*   float32         sum2_9km;      // sum of squares 1km grid cells within overlying 9km grid cell */
/*   float32         var_9km;       // variance 1km grid cells within overlying 9km grid cell */

/* } VarProc9kmFloat32Adt; */


// PRIOR: was   CtrlStruct  NEW: CtrlProc9kmAdt
typedef struct tagCtrlProc9kmAdt {
  time_t     strtSec;          // Begin time
  time_t     endiSec;          // End time
  float64    elapSec;          // Elapsed time
  char       dtBuf[32];        // Message buffer
  float32    testval;             
  // LogStruct  LogFile;          // logfile
} CtrlProc9kmAdt ; // was: CtrlStruct;


// --module: tcfSesAggrProc9km.c ------------------------------------
CtrlProc9kmAdt *tcfSesGetCtrlAggrProc9km(void) ;

// in process of final conversion over to l4c_xxxx formats
void tcfSesInitAggrProc9km(void);
void tcfSesAggrProc9km_close(void);
// deprecated abort

int tcfPostProc9kmDriver(void);

// --module: l4c_PostProc9km_func.c ------------------------------------
int tcfPostProc_isInCell(uint8 pft_index, float32 stateval);

int convert_1km_to_9km_by_pft(PftAdt PFT, char *outPath, char *iFpath, VarFloat32Adt *STATE);

uint8 tcf_qa_reclas(float32 error, float32 error_mn, float32 error_mx, uint32 qa_rank_mn, uint32 qa_rank_mx);

#endif
