// ---------------------------------------------------------------
// module       : l4c_DAILY_sci_io.c
// purpose      : Implement general HDF5 services for L4_C.  
// project      : SMAP L4C science development.
// dependencies : HDF4 4.2.x, HDF5 v1.8.x or later libraries, L4C FRAMEWORK APIs
// revised      : 2014-02-21T00:56, split off from l4c_DAILY_hdf5.c
// history      : n/a
// author       : jglassy
// notes        : Namespace signature: :"l4c_Hdf5_XXXXX"
// ---------------------------------------------------------------

#include "l4c_DAILY.h"
#include "l4c_DAILY_prot.h"



// ---------------------------------------------------------------
// function     : 
// purpose      : Read the (3) SOC pool layers and npp sum as M09 
// project      : SMAP L4C science development.
// dependencies : HDF4 4.2.x, HDF5 v1.8.x or later libraries, L4C FRAMEWORK APIs
// revised      : 2014-02-21T00:56, split off from l4c_DAILY_hdf5.c
// history      : n/a
// author       : jglassy
// notes        : split i/o out ..
int l4c_Read_SOC(void)
{
 SesCtl *sesCtl_p = l4c_GetSesCtl();
 herr_t ret = -1;
 hid_t  soc_id = -1;
 
 
 // <JMG> 3/11/2014, fetch previously opened SOC handle
 soc_id =  sesCtl_p->soc_file_id ;
 
 if((sesCtl_p->soc_id = H5Fopen(sesCtl_p->inputSOCPath, 
		H5F_ACC_RDONLY, H5P_DEFAULT)) <= 0)
 {
	xLogMsg("@E l4c_Read_SOC: Cannot find or open HDF5 file (%s) status: %d\n",
			hdf5Path, soc_id);
	exit(-1);
 } else {
	xLogMsg("@A l4c_Read_SOC: HDF5 file %s opened. ID assigned: %d\n",
	hdf5Path, soc_id);
	ret =0;
 }  
 
 // SOC file intentionally left open, and closed at end of session

 return 0;
 
} // end:: l4c_Read_SOC()


